/* This file is part of Roboarm.
 *
 * Roboarm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Roboarm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Roboarm; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package ch.educeth.roboarm;

import java.awt.*;
import java.awt.event.*;

/**
 * Diese Klasse ist der Event-Handler waehrend der Eingabe eines Streckenzuges (Pfadeingabe).
 */
public class PathHandler extends BasicHandler {
   private boolean firstTime=true;
   private int lastS;private int lastT;
   private CoordinatePanel c;private CoordinatePanel activePanel;

   public PathHandler() {
      CoordinatePanel.drawPath=false;
      CoordinatePanel.drawGoals=true;
      cAB.initGoals();
      cXY.initGoals();

      cAB.counter=0;
      cAB.update(AnimationLoop.data,null);
      cXY.counter=0;
      cXY.update(AnimationLoop.data,null);
   }

   public void mouseClicked(MouseEvent e) {
      info.setText(null);
      int s=e.getX(), t=e.getY();
      c=(CoordinatePanel) e.getSource();

      if (firstTime) {
         firstTime=false;
         activePanel=c;
         AnimationLoop.isAB=(c==cAB);

         String className = c.getClass().getName();
         AnimationLoop.createSingleInstance(RoboArmFactory.getAnimationLine(RoboArmFactory.getClassSubString(className).substring(0,2)));

         lastS=c.pos1;
         lastT=c.pos2;
      }

      if(c!=activePanel) return;

      if(c.isPointAllowed(s,t)&& c.isLineAllowed(lastS, lastT, s, t)) {
         c.addGoal(s-c.offsetWidth,c.offsetHeight-t);

         lastS=s;
         lastT=t;

         c.counter=0;
         c.update(AnimationLoop.data,null);
      } else info.setText("Dieser Punkt ist nicht erreichbar!");
   }

   public void mouseMoved(MouseEvent e) {
      int s=e.getX(), t=e.getY();
      c=(CoordinatePanel) e.getSource();

      if((activePanel==null || c==activePanel) && c.isPointAllowed(s,t)) {
         c.drawNextGoal=true;
         c.next1=s;
         c.next2=t;
         c.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
      } else {
         c.drawNextGoal=false;
         c.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      }

      c.currentX=s; c.currentY=t;

      c.counter=0;
      c.update(AnimationLoop.data,null);
   };

   public void mouseExited(MouseEvent e) {
      c=(CoordinatePanel) e.getSource();
      c.drawNextGoal=false;
      c.counter=0;
      c.update(AnimationLoop.data,null);
   }

   public void mouseDragged(MouseEvent e) {}
}
