/* This file is part of Roboarm.
 *
 * Roboarm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Roboarm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Roboarm; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package ch.educeth.roboarm;

import java.awt.*;
import java.util.*;
import javax.swing.*;

/**
 * Superklasse aller im Applet verwendeten 'graphischen Panels'. Alle diese Panel sind
 * Observer des Datanmodells (Model-View-Pattern)
 */
public abstract class SimpleDrawablePanel extends JPanel implements Observer{
   public static boolean doNotDraw;
   protected static Stroke pathStroke = new BasicStroke(2.0f,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);

/**
 * ChartKlasse; wird von der Klasse ABPanel und von TPanel verwendet.
 */
   protected SimpleChart myC;
   protected int counter;
   protected int offsetWidth;
   protected int offsetHeight;
   protected double personalDelay;
   protected Font f=new Font("Arial", Font.PLAIN, 10);

   public SimpleDrawablePanel(DataModel data, int w, int h, String title) {
      data.addObserver(this);

      setMinimumSize(new Dimension(w,h));
      setMaximumSize(new Dimension(w,h));
      setPreferredSize(new Dimension(w,h));

      setBorder(new BigTitledBorder(title));
   }

   public void paintComponent(Graphics g2) {
      g2.setColor(Color.white);
      g2.fillRect(0,0,getWidth(),getHeight());
   }
}